# Copyright 2015, 2018 Kevin Ryde

# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as published
# by the Free Software Foundation; either version 3, or (at your option) any
# later version.
#
# This file is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


              # (with-current-buffer buffer
              #   (goto-char (point-max))
              #   (skip-chars-backward "\r\n")
              #   (let ((end (point)))
              #     (forward-line -1)
              #     (buffer-substring (point) end)))


#------------------------------------------------------------------------------
# Some bits piping to gp directly rather than by a file

  my $flags = fcntl(GP, Fcntl::F_GETFL(),0);
  $flags &= ~ POSIX::O_NONBLOCK();
  fcntl(GP, Fcntl::F_SETFL(), $flags)
    or die "fcntl: $!";

  # printf "%b\n", $flags;
  # printf "%b\n", $flags;
  # printf "%b\n", ~ POSIX::O_NONBLOCK();
  # printf "%b\n", fcntl(GP, Fcntl::F_GETFL(),0);

  if ($harness) {
  } else {
    print @_;
  }

if ($harness) {
  ### finish ...
  close GP;
  if (! $harness->finish) {
    my $exit = $?;
    if (POSIX::WIFEXITED($exit)) {
      exit(POSIX::WEXITSTATUS($exit));
    } else {
      die "Error finishing gp sub-process: $?";
    }
  }
}



#------------------------------------------------------------------------------
# within VECTOR etc crunched line-by-line

        # $line =~ s/(^|[^\\])(\\\\)*%.*//; # % comments
        # $line =~ s/\\[,;]/ /g;            # ignore \, or \; spacing
        # $line =~ s/\\(phantom|hspace){[^}]*}/ /g;  # ignore TeX \phantom{...}
        # $line =~ s/\\(kern)-?[0-9.]+[a-z]+/ /g;    # ignore TeX \kern...
        # $line =~ s/\{([+-])\}/$1/g;       # {+} or {-}
        # $line =~ s/&/,/g;                 # & as field separator
        # $line =~ s|\\[td]?frac(\d)(\d)|($1)/($2)|g;              # \frac23
        # $line =~ s|\\[td]?frac\{([^}]*)}\{([^}]*)}|($1)/($2)|g;  # \frac{}{}
        # $line =~ s/\\(sqrt\d+)\s*(i?)/$1$2/g;    # \sqrt2 or \sqrt3 i
        # $line =~ s/([0-9.)]+)[ \t]*i/$1*I/g;     # complex number 123 i
        # $line =~ s/\bi[ \t]*([0-9.]+)/I*$1/g;    # complex number i 123
        # $line =~ s/([+-])[ \t]*(I)\b/$1$2/g;     # complex number +- i 123
        # $line =~ s/\bi\b/I/g;             # complex number i -> I
        # if ($within eq 'MATRIX') {
        #   $line =~ s/\\\\/;/g;            # row separator \\
        # } else {
        #   $line =~ s/;/,/g;               # semi as separator
        # }
        # $line =~ s|[^-+*/^()0-9.I,; \t]||sg;  # strip anything else
        # $line =~ s/(^|;)(\s*,)+/$1/sg;    # strip leading commas
        # $line =~ s/,(\s*,)+/,/sg;         # strip duplicated commas
        # $line =~ s/,[ \t]*$//;            # strip trailing commas
        # # print "\\ ",$line,"\n";
        # $line =~ s/[ \t]*$//;             # strip trailing whitespace
        # $line = decimals_to_fractions($line);
        # if ($line ne '') {
        #   $output->($join,$line,"\n");
        #   $join = ($line =~ /;$/ ? "\n" : ",\n");
        # }


#------------------------------------------------------------------------------
# maybe reading pm files of a dist

# } elsif ($arg eq '-dist') {
#   $exit = 1;
#   require ExtUtils::Manifest;
#   my $href = ExtUtils::Manifest::maniread();
#   my @filenames = grep m{^lib/.*\.pm$|^[^/]\.pm$}, keys %$href;
#   $good &= $class->test_files(@filenames);

# # if ($exit) {
# #   $class->diag ("gp-inline total $total_expressions checks in $total_files files");
# #   exit($good ? 0 : 1);
# # }
#
# sub diag {
#   my $self = shift;
#   if (eval { Test::More->can('diag') }) {
#     Test::More::diag (@_);
#   } else {
#     my $msg = join('', map {defined($_)?$_:'[undef]'} @_)."\n";
#     # $msg =~ s/^/# /mg;
#     print STDERR $msg;
#   }
# }


